package com.wms.utils;

import com.alibaba.fastjson2.JSON;

/**
 * WMS字符串工具类
 * @author 梁州
 * &#064;date  2023/2/13
 */
public class StringUtils {
    /** 空字符串 */
    private static final String NULLSTR = "";

    /** 下划线 */
    private static final char SEPARATOR = '_';

    public static boolean isEmpty(String value) {
        return value == null || value.equals(NULLSTR);
    }

    public static boolean isNotEmpty(String value) {
        return !isEmpty(value);
    }

    /**
     * 驼峰转下划线命名
     */
    public static String toUnderScoreCase(String str)
    {
        if (str == null)
        {
            return null;
        }
        StringBuilder sb = new StringBuilder();
        // 前置字符是否大写
        boolean preCharIsUpperCase = true;
        // 当前字符是否大写
        boolean curreCharIsUpperCase = true;
        // 下一字符是否大写
        boolean nexteCharIsUpperCase = true;
        for (int i = 0; i < str.length(); i++)
        {
            char c = str.charAt(i);
            if (i > 0)
            {
                preCharIsUpperCase = Character.isUpperCase(str.charAt(i - 1));
            }
            else
            {
                preCharIsUpperCase = false;
            }

            curreCharIsUpperCase = Character.isUpperCase(c);

            if (i < (str.length() - 1))
            {
                nexteCharIsUpperCase = Character.isUpperCase(str.charAt(i + 1));
            }

            if (preCharIsUpperCase && curreCharIsUpperCase && !nexteCharIsUpperCase)
            {
                sb.append(SEPARATOR);
            }
            else if ((i != 0 && !preCharIsUpperCase) && curreCharIsUpperCase)
            {
                sb.append(SEPARATOR);
            }
            sb.append(Character.toLowerCase(c));
        }

        return sb.toString();
    }

    /**
     * 驼峰式命名法
     * 例如：user_name->userName
     */
    public static String toCamelCase(String s)
    {
        if (s == null)
        {
            return null;
        }
        if (s.indexOf(SEPARATOR) == -1)
        {
            s = s.toLowerCase();
            return s;
        }
        s = s.toLowerCase();
        StringBuilder sb = new StringBuilder(s.length());
        boolean upperCase = false;
        for (int i = 0; i < s.length(); i++)
        {
            char c = s.charAt(i);

            if (c == SEPARATOR)
            {
                upperCase = true;
            }
            else if (upperCase)
            {
                sb.append(Character.toUpperCase(c));
                upperCase = false;
            }
            else
            {
                sb.append(c);
            }
        }
        return sb.toString();
    }

    /**
     * 将对象转为json字符串
     * @param o 实体类
     * @return 字符串
     */
    public static String convertJsonString(Object o) {
        return JSON.toJSONString(o);
    }

    /**
     * 往字符串左侧添加字符
     * @param value 原字符
     * @param size 目标字符串长度
     * @param padStr 添加的字符
     * @return 结果
     */
    public static String padLeft(String value, int size, String padStr) {
        return org.apache.commons.lang3.StringUtils.leftPad(value, size, padStr);
    }

    /**
     * 往字符串右侧添加字符
     * @param value 原字符
     * @param size 目标字符串长度
     * @param padStr 添加的字符
     * @return 结果
     */
    public static String padRight(String value, int size, String padStr) {
        return org.apache.commons.lang3.StringUtils.rightPad(value, size, padStr);
    }
}
